package com.byteslounge.service;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import com.byteslounge.service.impl.EmailNotificationService;
import com.byteslounge.service.impl.SmsNotificationService;

@Retention(RUNTIME)
@Target({FIELD, TYPE, METHOD})
public @interface NotificationServiceType {
	
	ServiceType value();
	
	public enum ServiceType{
		EMAIL(EmailNotificationService.class), SMS(SmsNotificationService.class);
		
		Class<? extends NotificationService> clazz;
		
		private ServiceType(Class<? extends NotificationService> clazz){
			this.clazz = clazz;
		}

		public Class<? extends NotificationService> getClazz() {
			return clazz;
		}
	}
}
