package com.byteslounge.service.impl;

import javax.enterprise.inject.Any;
import javax.enterprise.inject.Instance;
import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.Annotated;
import javax.enterprise.inject.spi.InjectionPoint;

import com.byteslounge.service.NotificationService;
import com.byteslounge.service.NotificationServiceProducer;
import com.byteslounge.service.NotificationServiceType;

public class NotificationServiceFactory {

	@Produces
	@NotificationServiceProducer
	public NotificationService createNotificationService(@Any Instance<NotificationService> instance, InjectionPoint ip){
		
		Annotated annotated = ip.getAnnotated();
		NotificationServiceType notificationTypeAnnotation = annotated.getAnnotation(NotificationServiceType.class);
		Class<? extends NotificationService> notificationServiceType = notificationTypeAnnotation.value().getClazz();
		return instance.select(notificationServiceType).get();
		
	}
}
