package com.byteslounge.servlet;

import java.io.IOException;

import javax.inject.Inject;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.byteslounge.service.NotificationService;
import com.byteslounge.service.NotificationServiceProducer;
import com.byteslounge.service.NotificationServiceType;
import com.byteslounge.service.NotificationServiceType.ServiceType;

@WebServlet(name = "testServlet", urlPatterns = {"/testServlet"})
public class TestServlet extends HttpServlet {

	private static final long serialVersionUID = -3995970242890631574L;
	
	@Inject
	@NotificationServiceProducer
	@NotificationServiceType(ServiceType.SMS)
	private NotificationService notificationService;
	
	protected void doGet(HttpServletRequest request,
		    HttpServletResponse response)
		    throws ServletException, IOException {
		
		notificationService.sendNotification();
		
	}
	
}
